
package de.ivu.elect.business.stimmeingabe.control;

import static org.apache.commons.lang3.StringUtils.isNotBlank;

import de.ivu.elect.business.stimmeingabe.control.plausi.StimmeingabePlausiResult;
import de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler;

public class StimmeingabefehlerFactory {

  public StimmeingabefehlerFactory() {
    super();
  }

  public Stimmeingabefehler fromStimmeingabePlausiResult(StimmeingabePlausiResult stimmeingabePlausiResult) {
    Stimmeingabefehler stimmeingabefehler = new Stimmeingabefehler();
    stimmeingabefehler.setStimmeingabe(stimmeingabePlausiResult.getStimmeingabe());
    stimmeingabefehler.setStimmeingabePlausiTyp(stimmeingabePlausiResult.getStimmeingabePlausiTyp());

    stimmeingabefehler.setFehlerart(stimmeingabePlausiResult.getStimmeingabefehlerFehlerart());
    stimmeingabefehler.setBeschreibung(bestimmeFehlerBeschreibung(stimmeingabePlausiResult));
    stimmeingabefehler.setErwarteteAnzahlEingabe(stimmeingabePlausiResult.getAnzahlSollEingabe());

    return stimmeingabefehler;

  }

  private String bestimmeFehlerBeschreibung(StimmeingabePlausiResult plausiResult) {
    StringBuilder result = new StringBuilder();

    String fehlerschluessel = plausiResult.getStimmeingabefehlerFehlerschluessel();

    if (isNotBlank(fehlerschluessel)) {
      result.append(fehlerschluessel).append(": ");
    }

    result.append(plausiResult.getStimmeingabefehlerBeschreibung());

    return result.toString();
  }
}
